<%@ page import="org.wso2.registry.web.actions.ResourceDetailsAction" %>
<%@ page import="org.wso2.registry.web.UIConstants" %>
<%@ page import="java.util.Iterator" %>
<%@ page import="org.wso2.registry.web.actions.utils.Permission" %>

<%
    ResourceDetailsAction resource = (ResourceDetailsAction) request.getSession().getAttribute(UIConstants.RESOURCE_BEAN);
    String errorMessage = (String) request.getSession().getAttribute(UIConstants.ERROR_MESSAGE);
    if (errorMessage != null) {
        request.getSession().removeAttribute(UIConstants.ERROR_MESSAGE);
    }
%>

<% if (errorMessage != null) { %>
<div class="error-message"><%=errorMessage%></div>
<% } %>

<h3>User Permissions</h3>
<div id="userPermisionsDiv" class="userPermisionsDiv leftSpace">

<h4>Add New Permissions</h4>
<form theme="simple">
<table width="100%" border="0" cellpadding="5" cellspacing="0">
    <tr>
            <td>User</td>
            <td>
                <select id="userToAuthorize" name="userToAuthorize">
                    <%
                        Iterator iUsers = resource.getUserNames().iterator();
                        while (iUsers.hasNext()) {
                            String regUser = (String) iUsers.next();
                    %>
                    <option value="<%=regUser%>"><%=regUser%></option>
                    <% } %>
                </select>

            </td>
            <td align="right">Action</td>
            <td>
                <select id="actionToAuthorize" name="actionToAuthorize">
                    <option value="1">-- Select an action --</option>
                    <option value="2">Read</option>
                    <option value="3">Write</option>
                    <option value="4">Delete</option>
                    <option value="5">Authorize</option>
                </select>
            </td>
            <td>
                <input type="radio" id="permissionAllow" name="permissionType" value="1" checked="checked" />Allow <input type="radio" id="permissionDeny" name="permissionType" value="2" />Deny
            </td>
            <td align="right"><input type="button" class="button" value="Add Permission" onclick="addUserPermission('<%=resource.getPath()%>')"/></td>
    </tr>
</table>
</form>
<h4 style="margin-top:10px;">Defined User Permissions</h4>
<form name="permissions" theme="simple" method="post">
    <input type="hidden" id="pInput" name="permissionInput" value=""/>
    <input type="hidden" name="pathToAuthorize" value="<%=resource.getPath()%>"/>
    <table width="100%" class="data-table" border="0" cellpadding="3" cellspacing="0">
        <tr >
            <th rowspan="2" align="left" style="width:120px;" >User Name </th>
            <th colspan="2" align="center">Read</th>
            <th colspan="2" align="center">Write</th>
            <th colspan="2" align="center">Delete</th>
            <th colspan="2" align="center">Authorize</th>
        </tr>
        <tr>
            <th align="center">Allow</th>
            <th align="center">Deny</th>
            <th align="center">Allow</th>
            <th align="center">Deny</th>
            <th align="center">Allow</th>
            <th align="center">Deny</th>
            <th align="center">Allow</th>
            <th align="center">Deny</th>
        </tr>

        <%
            Iterator iUserPermissions = resource.getUserPermissions().iterator();
            while (iUserPermissions.hasNext()) {
                Permission permission = (Permission) iUserPermissions.next();
        %>

        <tr>
            <td><%=permission.getUserName()%></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="ra" <% if (permission.isReadAllow()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="rd" <% if (permission.isReadDeny()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="wa" <% if (permission.isWriteAllow()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="wd" <% if (permission.isWriteDeny()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="da" <% if (permission.isDeleteAllow()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="dd" <% if (permission.isDeleteDeny()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="aa" <% if (permission.isAuthorizeAllow()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="ad" <% if (permission.isAuthorizeDeny()) { %> checked <% } %>/></td>
        </tr>
        <% } %>
        <tr>
            <td colspan="7" align="right"><input type="button" class="button" value="Apply All Permissions" onclick="processPermissions('<%=resource.getPath()%>');" style="margin-top:5px; float:right;" /><span style="clear:both;" /></td>
        </tr>
    </table>
</form>
</div>

<h3 style="padding-top:20px;">Role Permissions</h3>
<div id="rolePermisionsDiv" class="rolePermisionsDiv leftSpace">
<h4>New Role Permissions</h4>
<form theme="simple">
<table width="100%" border="0" cellpadding="5" cellspacing="0">
    <tr>
            <td>Role</td>
            <td>
                <select id="roleToAuthorize" name="roleToAuthorize">
                    <%
                        Iterator iRoles = resource.getRoleNames().iterator();
                        while (iRoles.hasNext()) {
                            String regRole = (String) iRoles.next();
                    %>
                    <option value="<%=regRole%>"><%=regRole%></option>
                    <% } %>
                </select>

            </td>
            <td align="right">Action</td>
            <td>
                <select id="roleActionToAuthorize" name="actionToAuthorize">
                    <option value="1">-- Select an action --</option>
                    <option value="2">Read</option>
                    <option value="3">Write</option>
                    <option value="4">Delete</option>
                    <option value="5">Authorize</option>
                </select>
            </td>
            <td>
                <input type="radio" id="rolePermissionAllow" name="permissionType" value="1" checked="checked" />Allow <input type="radio" id="rolePermissionDeny" name="permissionType" value="2" />Deny
            </td>
            <td align="right"><input type="button" class="button" value="Add Permission" onclick="addRolePermission('<%=resource.getPath()%>')"/></td>
    </tr>
</table>
</form>
<h4 style="margin-top:10px;">Defined Role Permissions</h4>
<form name="rolePermissions" theme="simple">
    <input type="hidden" id="pRoleInput" name="permissionInput" value=""/>
    <input type="hidden" name="pathToAuthorize" value="%{path}"/>
    <table width="100%" class="data-table" border="0" cellpadding="3" cellspacing="0">
        <tr >
            <th rowspan="2" align="left" >Role Name </th>
            <th colspan="2" align="center">Read</th>
            <th colspan="2" align="center">Write</th>
            <th colspan="2" align="center">Delete</th>
            <th colspan="2" align="center">Authorize</th>
        </tr>
        <tr>
            <th align="center">Allow</th>
            <th align="center">Deny</th>
            <th align="center">Allow</th>
            <th align="center">Deny</th>
            <th align="center">Allow</th>
            <th align="center">Deny</th>
            <th align="center">Allow</th>
            <th align="center">Deny</th>
        </tr>

        <%
            Iterator iRolePermissions = resource.getRolePermissions().iterator();
            while (iRolePermissions.hasNext()) {
                Permission permission = (Permission) iRolePermissions.next();
        %>

        <tr>
            <td><%=permission.getUserName()%></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="ra" <% if (permission.isReadAllow()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="rd" <% if (permission.isReadDeny()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="wa" <% if (permission.isWriteAllow()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="wd" <% if (permission.isWriteDeny()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="da" <% if (permission.isDeleteAllow()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="dd" <% if (permission.isDeleteDeny()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="aa" <% if (permission.isAuthorizeAllow()) { %> checked <% } %>/></td>
            <td width="100"><input type="checkbox" name="<%=permission.getUserName()%>" value="ad" <% if (permission.isAuthorizeDeny()) { %> checked <% } %>/></td>
        </tr>
        <% } %>
        <tr>
            <td colspan="7" align="right"><input type="button" class="button" value="Apply All Permissions" onclick="processRolePermissions('<%=resource.getPath()%>');" style="float:right;margin-top:5px;" /><span style="clear:both;" /></td>
        </tr>
    </table>

    

</form>
</div>
